org.cpsolver.ifs.assignment.context

## Class AssignmentContextHolderMap<V extends Variable<V,T>,T extends Value<V,T>>

- java.lang.Object
- - org.cpsolver.ifs.assignment.context.AssignmentContextHolderMap<V,T>

- Type Parameters:
    `V` - Variable
    `T` - Value
  All Implemented Interfaces:
    AssignmentContextHolder<V,T>
  Direct Known Subclasses:
    DefaultParallelAssignmentContextHolder, DefaultSingleAssignmentContextHolder

      public class AssignmentContextHolderMap<V extends Variable<V,T>,T extends Value<V,T>>
      extends Object
      implements AssignmentContextHolder<V,T>

  A simple assignment context holder implementation using `HashMap` to store all the assignment contexts. `AssignmentContextReference.getIndex()` are used to index the map.
  Version:
    IFS 1.3 (Iterative Forward Search)
    Copyright (C) 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses.
  Author:
    Tomáš Müller
  See Also:
    `AssignmentContext`, `AssignmentContextReference`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Map<Integer,AssignmentContext>` | `iContexts`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AssignmentContextHolderMap()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `<C extends AssignmentContext> void` | `clearContext(AssignmentContextReference<V,T,C> reference)` Clear an assignment context that is associated with the given a reference.
    `<U extends AssignmentContext> U` | `getAssignmentContext(Assignment<V,T> assignment, AssignmentContextReference<V,T,U> reference)` Return assignment context for the given assignment and reference.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### iContexts

          protected Map<Integer,AssignmentContext> iContexts

  - ### Constructor Detail

    - #### AssignmentContextHolderMap

          public AssignmentContextHolderMap()

  - ### Method Detail

    - #### getAssignmentContext

          public <U extends AssignmentContext> U getAssignmentContext(Assignment<V,T> assignment,
                                                                      AssignmentContextReference<V,T,U> reference)

      Description copied from interface: `AssignmentContextHolder`
      Return assignment context for the given assignment and reference. A new assignment context is created when there is not assignment context associated with the given reference yet.
      Specified by:
        `getAssignmentContext` in interface `AssignmentContextHolder<V extends Variable<V,T>,T extends Value<V,T>>`
      Type Parameters:
        `U` - assignment context type
      Parameters:
        `assignment` - current assignment (there is only one assignment associated with one holder, but the assignment is passed so that `HasAssignmentContext.createAssignmentContext(Assignment)` can be called if needed
        `reference` - a reference created by calling `Model.createReference(HasAssignmentContext)`
      Returns:
        an assignment context

    - #### clearContext

          public <C extends AssignmentContext> void clearContext(AssignmentContextReference<V,T,C> reference)

      Description copied from interface: `AssignmentContextHolder`
      Clear an assignment context that is associated with the given a reference. If there is any created for the reference.
      Specified by:
        `clearContext` in interface `AssignmentContextHolder<V extends Variable<V,T>,T extends Value<V,T>>`
      Type Parameters:
        `C` - assignment context type
      Parameters:
        `reference` - a reference (which can be stored within the model, e.g., as an instance variable of a constraint)